100 CLS
120 PRINT "                  *** BALLIT.BAS ***"
140 PRINT "           Programma di Johannes Fante del DWJ"
160 PRINT "           Tradotto e ampliato da Edoardo Mori": PRINT
170 PRINT " NB: Per separare i decimali usare il PUNTO e non la virgola!": PRINT
180 PRINT "       Dati del proiettile per cui eseguire i calcoli": PRINT
200 INPUT "Diametro del proiettile in millimetri              : "; ca#: PRINT
220 INPUT "Peso del proiettile in grammi                      : "; m#: PRINT
230 PRINT " ": PRINT : PRINT
240 PRINT "                    MENU"
260 PRINT "1 - Calcolo della traiettoria e dei dati relativi"
280 PRINT "2 - Calcolo della penetrazione nel legno e della relativa cavit"
300 PRINT "3 - Calcolo della penetrazione nel ferro"
320 PRINT "4 - Calcolo della penetrazione nell'osso"
340 PRINT "5 - Calcolo della penetrazione nel corpo umano"
360 PRINT "6 - Variazione della velocit in relazione alla lunghezza della canna"
365 PRINT "7 - Velocit residua dopo perforazione ferro"
366 PRINT "8 - Velocit residua dopo perforazione legno di abete"
368 PRINT "9 - Introduzione dei dati di un diverso proiettile"
370 PRINT "0 - Uscita dal programma"
380 PRINT "    Batti il numero della elaborazione desiderata e poi INVIO": PRINT
400 INPUT A
420 IF A = 1 THEN 530
440 IF A = 2 THEN 6290
460 IF A = 3 THEN 7090
480 IF A = 4 THEN 10000
500 IF A = 5 THEN 8090
520 IF A = 6 THEN 9090
522 IF A = 7 THEN 10500
525 IF A = 8 THEN 10410
526 IF A = 9 THEN 170
528 IF A = 0 THEN END
530 CLS
540 PRINT "           CALCOLO DI UNA TRAIETTORIA"
560 PRINT "            Calcolo dei coefficienti ": PRINT
600 PRINT "1 - Vuoi che sia il programma a calcolare il coeff. aereodinamico?"
620 PRINT "2 - Vuoi inserire tu un particolare coeff. aereodinamico?": PRINT
680 PRINT "Scrivi 1 oppure 2 e batti ENTER/INVIO"
700 INPUT A
720 IF A = 1 THEN 760
740 IF A = 2 THEN GOSUB 6100
760 CLS
780 PRINT "       CALCOLO DEL COEFFICIENTE K DEL PROIETTILE"
800 PRINT "              Inserimento dei dati": PRINT : PRINT
820 INPUT "Velocit in m/s all'inizio del tratto considerato  : "; vi#: PRINT
840 INPUT "Velocit in m/s al termine del tratto considerato  : "; vf#: PRINT
860 INPUT "Lunghezza in metri del tratto considerato          : "; t#: PRINT
880 INPUT "Densit dell'aria (standard 1.225 kg/mc)           : "; de#: PRINT
900 cw# = (LOG(vi#) - LOG(vf#)) / (de# * .000392699# * ca# ^ 2 * t# / m#)
920 k# = (ca# ^ 2 * cw# * de#) / (m# * 2546.479)
940 PRINT : PRINT "Il coeff. aereodinamico nel tratto : "; USING "#.#####"; cw#;
960 PRINT : PRINT "Il coefficiente  K :                 "; USING "#.########"; k#;
980 PRINT : PRINT "     "
1010 REM --- Immissione dei dati sullo schermo ---
1030 PRINT "       INSERIMENTO DATI PER CALCOLO TRAIETTORIA": PRINT : PRINT
1040 INPUT "Velocit iniziale in metri al secondo              : "; v#: PRINT
1070 INPUT "Distanza di azzeramento in metri                   : "; fe#: PRINT
1080 INPUT "Distanza massima in metri da calcolare             : "; me#: PRINT
1090 INPUT "Intervalli di calcolo in metri (ogni x  m)         : "; s#: PRINT
1100 INPUT "Velocit del vento laterale in metri al secondo    : "; qw#: PRINT
1102 INPUT "Altezza della linea di mira in millimetri          : "; hv#: PRINT
1104 hv# = hv# / 1000
1110 REM --- Dati della tabella ---
1120 CLS
1130 PRINT "Dati della traiettoria (Vento laterale di: "; qw#; " m/s)": PRINT
1140 PRINT " Dist-     Cadu-     Ordi-    Veloci-     Ener-    Deviaz.  Tempo    Scarto"
1150 PRINT " anza      ta        nata     t res.     gia      vento    volo     mira  "
1160 PRINT " (m)       (cm)      (cm)     (m/s)       (J)      (cm)     (s)      (cm)  "
1170 PRINT "---------------------------------------------------------------------------"
2000 REM --- Calcoli ---
2010 REM --- Calcolo della caduta alla distanza di azzeramento ---
2020 h1# = 2.453 / ((k# ^ 2) * (v# ^ 2))
2030 h2# = (EXP(2 * k# * fe#)) - (2 * k# * fe#) - 1
2040 y# = h1# * h2#
2042 REM --- Calcolo della DOA ---
2044 ys# = (8 / 2) + .4 * (hv# * 100)
2046 tm# = .090305 * SQR(ys#)
2048 gee# = (1 / k#) * LOG((v# * k# * tm#) + 1)
2050 e% = 0 - s#
2060 FOR i% = 1 TO (me# + s#) STEP s#
2070 e% = e% + s#
2080 l = LEN(STR$(e%))
2090 REM  --- Calcolo della caduta del proiettile  ___
2100 h3# = 2.453 / ((k# ^ 2) * (v# ^ 2))
2110 h4# = (EXP(2 * k# * e%)) - (2 * k# * e%) - 1
2120 ye# = h3# * h4#
2130 REM --- Calcolo delle ordinate del proiettile ---
2140 yh# = e% * (y# / fe#) - ye#
2150 REM --- Calcolo della velocit del proiettile ----
2160 ve# = v# * (EXP(-k# * e%))
2170 REM --- Calcolo dell'energia ---
2180 j# = (m# * (ve# * ve#)) / 2000
2190 REM --- Calcolo del tempo di volo ---
2200 t# = (1 / (v# * k#)) * ((EXP(k# * e%)) - 1)
2210 REM --- Calcolo della deviazione per il vento ---
2220 w# = (100 * qw#) * (t# - (e% / v#))
2230 REM --- Calcolo delle ordinate rispetto alla linea di mira ---
2240 hyv# = (hv# * (fe# - e%) / fe#)
2250 yv# = yh# - hyv#
3000 REM --- Formattazione e stampa sullo schermo ---
3100 PRINT TAB(5 - l); e%;
3110 PRINT USING "########.#"; ye# * -100;
3120 PRINT USING "########.#"; yh# * 100;
3130 PRINT USING "########.#"; ve#;
3140 PRINT USING "##########"; j#;
3150 PRINT USING "#######.##"; w# * -1;
3160 PRINT USING "#####.####"; t#;
3170 PRINT USING "########.#"; yv# * 100
4000 NEXT i%: PRINT
5000 PRINT "La distanza ottimale di azzeramento  di m  :"; USING "####"; gee#;
5040 PRINT : PRINT "  "
5050 PRINT " 1 - Vuoi tornare al menu ? "
5060 PRINT " 2 - Vuoi introdurre i dati di un diverso proiettile ?"
5070 INPUT B
5075 CLS
5080 IF B = 1 GOTO 230
5090 IF B = 2 GOTO 180
6050 REM  --- Calcolo di K essendo noto Cx ---
6100 PRINT "                 INSERIMENTO DEI DATI": PRINT : PRINT
6140 INPUT "Valore del coeff. aereodinamico                    : "; cw#: PRINT
6200 INPUT "Densit dell'aria (standard 1.225 kg/mc)           : "; de#: PRINT
6220 k# = (ca# ^ 2 * cw# * de#) / (m# * 2546.479)
6240 PRINT : PRINT "Il coeff. aereodinamico nel tratto : "; USING "#.#####"; cw#;
6260 PRINT : PRINT "Il coefficiente  K :                 "; USING "#.########"; k#;
6280 GOTO 1030
6290 CLS : PRINT
6300 PRINT "           --- Penetrazione nel legno di abete --- ": PRINT : PRINT
6350 PRINT " Per proiettili non camiciati la penetrazione  inferiore del 20%": PRINT
6400 INPUT "Velocit di impatto del proiettile in m/s   : "; vf#: PRINT
6600 eg# = m# * vf# ^ 2 / 19620
6700 ph# = .0298 * m# * vf# ^ 1.5 / ca# ^ 2
6750 cv# = .00234 * (vf# ^ 1.5)
6800 PRINT : PRINT "La penetrazione nel legno  di cm :"; USING "###"; ph#;
6850 PRINT "Il volume della cavit nel legno  di cmc :"; USING "###.#"; cv#;
6900 GOTO 230
7090 CLS : PRINT
7300 PRINT "          --- Penetrazione in piastra di ferro ---": PRINT
7400 INPUT "Velocit di impatto del proiettile in m/s   : "; vf#: PRINT
7600 eg# = m# * (vf# ^ 2) / 19620
7700 pf# = .194 * ((eg# ^ 3) / (ca# ^ 5)) ^ (1 / 4)
7800 PRINT : PRINT "La penetrazione nel ferro  di cm   "; USING "###.##"; pf#;
7900 GOTO 230
8090 CLS : PRINT
8100 PRINT "         --- Penetrazione nel muscolo  umano ---": PRINT
8200 INPUT "Velocit di impatto del proiettile in m/s   : "; vf#: PRINT
8300 ds# = m# / (.0078539 * (ca# ^ 2))
8400 vm# = 125 * (1 / ds#) + 22
8500 pu# = 2.3 * ds# * LOG((vf# - vm#) / 50)
8600 PRINT : PRINT "La penetrazione nel muscolo umano  di cm  "; USING "###.#"; pu#;
8650 PRINT : PRINT "La velocit limite sulla cute  di m/s   "; USING "##"; vm#;
8700 GOTO 230
9090 CLS : PRINT
9100 PRINT "--- Variazione della velocit in relazione a lunghezza canna ---": PRINT
9150 PRINT "In questo calcolo per lunghezza della canna  si intende il percorso"
9200 PRINT "del proiettile nella canna e quindi la tratta misurata dalla punta"
9250 PRINT "del proiettile in camera alla bocca + la lunghezza del proiettile": PRINT
9350 INPUT "Velocit del proiettile in canna nota in m/s    : "; vf#: PRINT
9400 INPUT "Percorso del proiettile nella canna nota  in mm : "; mc#: PRINT
9450 INPUT "Peso della polvere in grammi                    : "; po#: PRINT
9500 INPUT "Percorso del proiettile nella canna diversa mm  : "; pc#: PRINT
9550 cr# = vf# / (((mc# / (10 * ca#)) ^ .25) * ((po# / m#) ^ .5))
9600 vn# = ((pc# / ((10 * ca#))) ^ .25) * cr# * ((po# / m#) ^ .5)
9650 PRINT : PRINT "Velocit nella nuova canna, m/s   "; USING "###"; vn#;
9700 GOTO 230
10000 CLS : PRINT
10050 PRINT "           --- Penetrazione nell'osso ---": PRINT
10100 PRINT "La costante C da impiegare  0.44 per proiettili di pistola camiciati,"
10150 PRINT "0.30 per proiettili di piombo arrotondati e 0.15 per wad-cutter"
10200 INPUT " Costante                                      : "; c#: PRINT
10250 INPUT "Velocit di impatto del proiettile in m/s      : "; vf#: PRINT
10300 pk# = c# * 10 * (m# / ca#) * ((vf# - 60) / 100) ^ 2
10350 PRINT : PRINT "La penetrazione nell'osso  di cm   "; USING "###"; pk#;
10400 GOTO 230
10410 CLS : PRINT
10420 PRINT " --- Velocit residua dopo perforazione di uno spessore di legno---"
10430 INPUT "Velocit di impatto del proiettile in m/s   : "; vf#: PRINT
10432 eg# = m# * vf# ^ 2 / 19620
10434 ph# = .0298 * m# * vf# ^ 1.5 / ca# ^ 2
10440 INPUT "Spessore del legno trapassato in cm                   : "; sp#
10460 vr# = (((ph# - sp#) * (ca# ^ 2)) / (.0298 * m#)) ^ (1 / 1.5)
10480 PRINT "La velocit residua del proiettile e di m/s   : "; USING "###"; vr#;
10482 GOTO 230
10500 CLS : PRINT
10550 PRINT "--- Velocit residua dopo perforazione di uno  spessore di ferro ---"
10560 PRINT " "
10600 INPUT "Velocit di impatto del proiettile in m/s    : "; vf#: PRINT
10650 INPUT "Spessore di ferro trapassato in cm           : "; pp#: PRINT
10700 eg# = m# * (vf# ^ 2) / 19620
10800 pf# = .194 * ((eg# ^ 3) / (ca# ^ 5)) ^ (1 / 4)
10850 er# = (((pf# - pp#) / .194) ^ 4 * ca# ^ 5) ^ (1 / 3)
10900 vr# = ((19620 * er#) / m#) ^ (.5)
11000 PRINT " La velocit residua del proiettile  di m/s : "; USING "###"; vr#;
11100 GOTO 230

